import { ref as $, reactive as te, computed as ve, toRefs as Ve, defineComponent as ge, onMounted as De, resolveComponent as m, openBlock as i, createBlock as v, withCtx as o, createElementVNode as X, renderSlot as A, createVNode as d, unref as e, createElementBlock as N, Fragment as K, renderList as Q, mergeProps as B, withModifiers as Ce, createTextVNode as q, toDisplayString as ne, createCommentVNode as z, resolveDirective as Re, withDirectives as ye, createSlots as Ae, resolveDynamicComponent as Te, normalizeProps as xe, guardReactiveProps as $e, withKeys as Ue, vShow as Le, isRef as Ne } from "vue";
import { ElMessage as Me, ElMessageBox as Ee, ElNotification as ze, ElButton as oe, ElButtonGroup as Ke, ElDialog as qe } from "element-plus";
import { useRoute as Ie } from "vue-router";
const x = $({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 200,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), s = $({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {}, columns: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
}), _e = $({});
function j(n) {
  let c;
  try {
    c = Array.isArray(n) ? [] : {}, n === null && (c = null);
  } catch {
    c = {};
  }
  for (const f in n)
    typeof n[f] == "object" ? c[f] = j(n[f]) : c[f] = n[f];
  return c;
}
function Pe(...n) {
  function c(a) {
    return typeof a == "object" && Object.prototype.toString.call(a) === "[object Object]";
  }
  let f = arguments.length, _ = arguments[0];
  c(_) || (_ = {});
  for (let a = 1; a < f; a++) {
    let h = arguments[a];
    if (c(h))
      for (let C in h)
        C === "__proto__" || _ === h[C] || _.hasOwnProperty(C) && (c(h[C]) ? _[C] = Pe(_[C], h[C]) : _[C] = h[C]);
  }
  return _;
}
function je(n, c) {
  let f = {}, _ = Object.getOwnPropertyNames(n), a = Object.getOwnPropertyNames(c);
  return _.length === a.length && _.forEach((h) => {
    n[h] !== c[h] && (f[h] = c[h]);
  }), f;
}
const ae = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeBatchDeteleHandler: "beforeBatchDeteleHandler",
  afterBatchDeteleHandler: "afterBatchDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function We(n = { debug: !1 }) {
  const c = te({
    hooks: {}
  });
  return Object.keys(n).forEach((_) => {
    _ !== "debug" && (c.hooks[_] = n[_]);
  }), {
    hookHandler: (_, a) => {
      let h = !1;
      try {
        n.debug && (console.group("DeBug\uFF1A", _), console.table(a.Data), console.groupEnd()), h = c.hooks[_](a);
      } catch {
        h = !0;
      }
      return h;
    }
  };
}
let w = {}, He = {};
const se = $(), Qe = (n) => {
  se.value = n.CrudRequest, x.value = Pe(x.value, n), be("\u3010\u521D\u59CB\u5316Options\u3011", n), w = { ...x.value }, He = { ...s.value };
}, Je = (n) => {
  _e.value = j(n), x.value = j(w), s.value = j(He), Ge(_e.value.source), x.value = Pe(x.value, _e.value), be("UseCrudStates\u4F20\u53C2\u3010props\u3011", _e.value), be("\u3010DefParams\u3011", x.value), be("\u3010CrudStates\u3011", s.value);
};
function he() {
  return { ...Ve(x.value) };
}
function k() {
  return { ...Ve(s.value) };
}
function ke() {
  return { ...Ve(_e.value) };
}
const we = () => {
  const n = _e.value, c = (t) => {
    let r = {};
    return n.rowKey && (r[n.rowKey] = t[n.rowKey]), n.rowKeys && n.rowKeys.forEach((y) => {
      r[y] = t[y];
    }), r;
  }, { hookHandler: f } = We(n.hooks);
  function _() {
    s.value.tableLoading = !0;
    const t = te({ ...s.value.initSearchModel, ...s.value.searchModel });
    for (const r in t)
      typeof t[r] == "string" && (t[r] = t[r].trim(), t[r] === "" && (t[r] = void 0)), t[r] === null && (t[r] = void 0);
    !f(ae.beforeQueryHandler, { CrudState: s.value, Data: t }) || se.value({
      url: n.url,
      name: x.value.ApiName.query,
      data: {
        pagenum: x.value.Page_PageParams.current,
        pagesize: x.value.Page_PageParams.pageSize,
        ...t
      }
    }).then((r) => {
      const { data: y, page: S } = r;
      setTimeout(() => {
        a(y, t), x.value.Page_PageParams.total = S.total, s.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      s.value.tableLoading = !1;
    });
  }
  const a = (t, r) => {
    Object.keys(r).filter((S) => r[S] != null).length == 0 && (s.value.originalData = t), s.value.originalData = j(t), f(ae.afterQueryHandler, { CrudState: s.value, Data: t }) && (s.value.tableData = j(t));
  };
  function h() {
    s.value.editModel = j(s.value.initEditModel);
    const t = te({ ...s.value.editModel });
    !f(ae.beforeAddHandler, { CrudState: s.value, Data: t }) || (s.value.Mode = "add", s.value.DialogVisible = !0);
  }
  const C = (t) => {
    const r = te({
      ...t
    });
    if (!f(ae.beforeEditHandler, { CrudState: s.value, Data: r }))
      return;
    const y = j(r);
    Object.keys(y).forEach((S) => {
      s.value.editModel[S] = y[S], s.value.editFormValue[S] = y[S];
    }), s.value.Mode = "edit", s.value.DialogVisible = !0;
  }, P = async (t) => {
    !t || await t.validate((r) => {
      if (r) {
        const y = te({
          ...s.value.editModel
        });
        if (!f(ae.beforeSubmitHandler, { CrudState: s.value, Data: y }))
          return;
        s.value.Mode === "add" ? F(y) : E(y);
      }
    });
  }, F = (t) => {
    s.value.submitLoading = !0;
    let r = t;
    t.FormData instanceof FormData && (r = t.FormData), se.value({ url: n.url, name: x.value.ApiName.add, data: r }).then(() => {
      s.value.DialogVisible = !1, me("\u65B0\u589E\u6210\u529F"), _(), s.value.submitLoading = !1;
    }).catch(() => {
      s.value.submitLoading = !1;
    });
  }, E = (t) => {
    s.value.submitLoading = !1;
    let r = t;
    if (t.FormData instanceof FormData)
      r = t.FormData;
    else {
      const y = je(s.value.editModel, r);
      if (JSON.stringify(y) === "{}")
        return s.value.submitLoading = !1, Me({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      r = {
        ...c(t),
        ...y
      };
    }
    se.value({ url: n.url, name: x.value.ApiName.edit, data: r }).then(() => {
      s.value.DialogVisible = !1, me("\u7F16\u8F91\u6210\u529F"), _(), s.value.submitLoading = !1;
    }).catch(() => {
      s.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: _,
    addRecord: h,
    editRecord: C,
    handleSubmit: P,
    delFlag: (t) => {
      Ee.confirm(`\u786E\u5B9A\u8981 \u201C${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...c(t),
          deleteFlag: t.deleteFlag == 0 ? 1 : 0
        });
        !f(ae.beforedisabledHandler, { CrudState: s.value, Data: r }) || se.value({
          url: n.url,
          name: x.value.ApiName.deleteFlag,
          data: r
        }).then(() => {
          me(`\u6570\u636E${t.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), _();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (t) => {
      Ee.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          ...c(t)
        });
        !f(ae.beforeDeteleHandler, { CrudState: s.value, Data: r }) || se.value({
          url: n.url,
          name: x.value.ApiName.delete,
          data: r
        }).then(() => {
          me("\u5220\u9664\u6210\u529F"), _();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      const t = s.value.multipleSelection.map((r) => r[n.rowKey]);
      Ee.confirm(`\u786E\u5B9A\u8981\u5220\u9664\u8FD9 ${t.length} \u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const r = te({
          [n.rowKey]: t,
          selection: s.value.multipleSelection
        });
        !f(ae.beforeBatchDeteleHandler, { CrudState: s.value, Data: r }) || se.value({
          url: n.url,
          name: x.value.ApiName.remove,
          data: r
        }).then(() => {
          me("\u6279\u91CF\u5220\u9664\u6210\u529F"), s.value.multipleSelection = [], s.value.CompRef.TableRef.clearSelection(), _();
        });
      }).catch(() => {
      });
    }
  };
};
function be(...n) {
  x.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...n);
}
const Ge = (n) => {
  const { filter: c, editor: f, column: _, columns: a } = n;
  s.value.ElementArrs = { filter: {}, editor: {}, column: {}, columns: {} };
  let h = {};
  c.forEach((P) => {
    try {
      h[P] = a[P].searchDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    s.value.ElementArrs.filter[P] = a[P];
  }), s.value.initSearchModel = j(h), s.value.searchModel = j(s.value.initSearchModel);
  let C = {};
  f.forEach((P) => {
    try {
      C[P] = a[P].addDefaultValue;
    } catch {
      return console.error("columns\u4E2D\u4E0D\u5B58\u5728\u53C2\u6570\uFF1A", P);
    }
    s.value.ElementArrs.editor[P] = a[P];
  }), s.value.initEditModel = j(C), _.forEach((P) => {
    s.value.ElementArrs.column[P] = a[P];
  }), s.value.ElementArrs.columns = a;
};
ve(() => {
  let n = [];
  for (const c in s.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(s.value.ElementArrs.editor, c) && s.value.ElementArrs.editor[c].type === "el-upload" && n.push(c);
  return n;
});
const me = (n, c = "success") => {
  ze({
    title: n,
    type: c,
    offset: 70,
    duration: 2500
  });
}, Xe = /* @__PURE__ */ ge({
  __name: "crud_SearchForm",
  setup(n) {
    const c = $(), { Form_LabelWidth: f } = he(), {
      CompRef: _,
      searchModel: a,
      ElementArrs: {
        value: { filter: h }
      }
    } = k();
    De(() => {
      _.value.SearchFormRef = c.value;
    });
    const C = (F) => {
      var E, V;
      return F.range ? (E = F.formProps) != null && E.type ? F.formProps.type + "range" : "daterange" : (V = F.formProps) != null && V.type ? F.formProps.type : "date";
    }, P = (F, E, V) => {
      a.value[E] === V ? a.value[E] = void 0 : a.value[E] = F.formProps.options[V].value;
    };
    return (F, E) => {
      const V = m("el-input"), T = m("el-form-item"), U = m("el-col"), t = m("el-input-number"), r = m("el-option"), y = m("el-select"), S = m("el-date-picker"), L = m("el-time-picker"), re = m("el-radio"), Y = m("el-radio-button"), W = m("el-radio-group"), ue = m("el-row"), Z = m("el-form"), ee = m("el-collapse-transition");
      return i(), v(ee, null, {
        default: o(() => [
          X("div", null, [
            A(F.$slots, "search-form", {}, void 0, !0),
            d(Z, {
              ref_key: "SearchFormRef",
              ref: c,
              model: e(a),
              "label-width": e(f)
            }, {
              default: o(() => [
                d(ue, null, {
                  default: o(() => [
                    A(F.$slots, "search-form-top", {}, void 0, !0),
                    (i(!0), N(K, null, Q(e(h), (u, D) => {
                      var J;
                      return i(), N(K, null, [
                        u.type === "el-input" ? (i(), v(U, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(V, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (i(), v(U, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(t, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (i(), v(U, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(y, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: o(() => [
                                    (i(!0), N(K, null, Q(u.formProps.options, (g) => (i(), v(r, {
                                      key: g.value,
                                      label: g.label,
                                      value: g.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !C(u).includes("range") ? (i(), v(U, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(S, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (i(), v(U, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(S, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: C(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((J = u.formProps) != null && J.isRange) && !u.range ? (i(), v(U, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (i(), v(U, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(L, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (i(), v(U, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: o(() => [
                            d(T, {
                              label: u.label,
                              prop: D
                            }, {
                              default: o(() => [
                                d(W, B({
                                  modelValue: e(a)[D],
                                  "onUpdate:modelValue": (g) => e(a)[D] = g
                                }, u.formProps), {
                                  default: o(() => [
                                    u.formProps.button ? z("", !0) : (i(!0), N(K, { key: 0 }, Q(u.formProps.options, (g) => (i(), v(re, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, D, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    u.formProps.button ? (i(!0), N(K, { key: 1 }, Q(u.formProps.options, (g) => (i(), v(Y, B({
                                      key: g.value,
                                      label: g.value,
                                      onClick: Ce((le) => P(u, D, g.value), ["prevent"])
                                    }, u.formProps), {
                                      default: o(() => [
                                        q(ne(g.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    A(F.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const Be = (n, c) => {
  const f = n.__vccOpts || n;
  for (const [_, a] of c)
    f[_] = a;
  return f;
}, Ye = /* @__PURE__ */ Be(Xe, [["__scopeId", "data-v-394e11ba"]]), Ze = { class: "edit" }, el = { class: "edit_form" }, ll = /* @__PURE__ */ ge({
  __name: "crud_EditForm",
  props: {
    height: Number
  },
  setup(n) {
    const c = $(), { Form_LabelWidth: f } = he(), {
      CompRef: _,
      editModel: a,
      Mode: h,
      ElementArrs: {
        value: { editor: C }
      },
      uploadFiles: P
    } = k();
    De(() => {
      _.value.EditFormRef = c.value;
    });
    const F = ve(() => {
      let t = {};
      return ke().source.value.editor.forEach((r) => {
        typeof C[r].visible == "function" ? C[r].visible(k(), h.value) && (t[r] = C[r]) : t[r] = C[r];
      }), t;
    }), E = ({ showFileList: t }) => {
      if (t)
        return !1;
      if (P.value[0])
        return URL.createObjectURL(P.value[0]);
    }, V = (t) => typeof t.disabled == "function" ? t.disabled(k(), h.value) : !1, T = (t) => {
      let r = { ...t };
      return Object.keys(r).forEach((y) => {
        typeof r[y] == "function" && (r[y] = r[y].bind(this, k()));
      }), r;
    }, U = (t, r, y) => {
      a.value[r] === y ? a.value[r] = void 0 : a.value[r] = t.formProps.options[y].value;
    };
    return (t, r) => {
      const y = m("el-input"), S = m("el-form-item"), L = m("el-col"), re = m("el-input-number"), Y = m("el-option"), W = m("el-select"), ue = m("el-date-picker"), Z = m("el-time-picker"), ee = m("el-cascader"), u = m("el-button"), D = m("el-image"), J = m("plus"), g = m("el-icon"), le = m("el-upload"), de = m("el-radio"), ie = m("el-radio-button"), ce = m("el-radio-group"), R = m("el-row"), O = m("el-form"), M = m("el-scrollbar");
      return i(), N("div", Ze, [
        d(M, {
          height: n.height,
          "max-height": n.height
        }, {
          default: o(() => [
            X("div", el, [
              A(t.$slots, "edit-form", { editModel: e(a) }, void 0, !0),
              d(O, {
                ref_key: "EditFormRef",
                ref: c,
                model: e(a),
                "label-width": e(f)
              }, {
                default: o(() => [
                  d(R, null, {
                    default: o(() => [
                      A(t.$slots, "edit-form-top", { editModel: e(a) }, void 0, !0),
                      (i(!0), N(K, null, Q(e(F), (l, p) => (i(), N(K, { key: p }, [
                        l.type === "el-input" ? (i(), v(L, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(y, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (i(), v(L, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(re, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (i(), v(L, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(W, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    (i(!0), N(K, null, Q(l.formProps.options, (b) => (i(), v(Y, {
                                      key: b.value,
                                      label: b.label,
                                      value: b.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (i(), v(L, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(ue, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (i(), v(L, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(Z, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (i(), v(L, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(ee, B({
                                  style: { width: "100%" },
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: V(l)
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (i(), v(L, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(le, B({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: p + "UploadRef",
                                  action: ""
                                }, T(l.formProps)), {
                                  default: o(() => {
                                    var b;
                                    return [
                                      ((b = l.formProps) == null ? void 0 : b.listType) !== "picture-card" ? (i(), v(u, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: o(() => [
                                          q(ne(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && E(l.formProps) ? (i(), v(D, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: E(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !E(l.formProps) ? (i(), v(g, { key: 2 }, {
                                        default: o(() => [
                                          d(J)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (i(), v(L, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: o(() => [
                            d(S, {
                              label: l.label,
                              prop: p,
                              rules: l.rules
                            }, {
                              default: o(() => [
                                d(ce, B({
                                  modelValue: e(a)[p],
                                  "onUpdate:modelValue": (b) => e(a)[p] = b,
                                  disabled: V(l)
                                }, l.formProps), {
                                  default: o(() => [
                                    l.formProps.button ? z("", !0) : (i(!0), N(K, { key: 0 }, Q(l.formProps.options, (b) => (i(), v(de, B({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((pe) => U(l, p, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(ne(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)),
                                    l.formProps.button ? (i(!0), N(K, { key: 1 }, Q(l.formProps.options, (b) => (i(), v(ie, B({
                                      key: b.value,
                                      label: b.value,
                                      onClick: Ce((pe) => U(l, p, b.value), ["prevent"])
                                    }, l.formProps), {
                                      default: o(() => [
                                        q(ne(b.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label", "onClick"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      A(t.$slots, "edit-form-bottom", { editModel: e(a) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const ol = /* @__PURE__ */ Be(ll, [["__scopeId", "data-v-08532dff"]]), al = { key: 1 }, tl = /* @__PURE__ */ ge({
  __name: "crud_Table",
  props: { height: Number },
  emits: ["row-contextmenu"],
  setup(n, { emit: c }) {
    const f = $(), { Table_isOpenMultipleSelection: _, Table_isOpenIndex: a, Table_isOpenExpand: h, Table_ExpandColumn: C, Table_MenuAlign: P, Table_MenuWidth: F, Page_PageParams: E, Permission: V } = he(), {
      CompRef: T,
      tableData: U,
      tableLoading: t,
      ElementArrs: {
        value: { filter: r, column: y, columns: S }
      },
      searchModel: L,
      multipleSelection: re
    } = k(), { rowKey: Y, keyName: W, Table_Attributes: ue } = ke(), { queryRecord: Z, editRecord: ee, delFlag: u, deleteRecord: D } = we();
    De(() => {
      T.value.TableRef = f.value;
    });
    const J = ve(() => {
      var R, O;
      return (((R = E == null ? void 0 : E.value) == null ? void 0 : R.current) - 1) * ((O = E == null ? void 0 : E.value) == null ? void 0 : O.pageSize) + 1;
    }), g = (R) => {
      re.value = R;
    }, le = (R, O, M, l) => {
      O.label && navigator.clipboard.writeText(M.innerText).then(() => {
        Me.success("\u590D\u5236\u6210\u529F\uFF01");
      });
    }, de = (R, O, M) => {
      M.preventDefault(), c("row-contextmenu", { row: R, column: O, event: M }, k());
    }, ie = (R, O, M) => {
      if (O.formProps) {
        const l = O.formProps.options.findIndex((p) => p.value == R[M]);
        return l === -1 ? R[M] : O.formProps.options[l].label;
      } else
        return R[M];
    }, ce = (R, O) => {
      let M = { ...R };
      return Object.keys(M).forEach((l) => {
        typeof M[l] == "function" && (M[l] = M[l].call(this, k(), O));
      }), M;
    };
    return (R, O) => {
      const M = m("el-empty"), l = m("el-table-column"), p = m("el-descriptions-item"), b = m("el-descriptions"), pe = m("el-input"), fe = m("el-button"), I = m("el-table"), Oe = Re("loading");
      return ye((i(), v(I, B({
        ref_key: "TableRef",
        ref: f,
        data: e(U),
        "row-key": e(Y),
        height: n.height,
        onCellDblclick: le,
        onSelectionChange: g,
        onRowContextmenu: de
      }, e(ue)), {
        empty: o(() => [
          d(M, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: o(() => [
          e(_) ? (i(), v(l, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(h) ? (i(), v(l, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: o((H) => [
              d(b, {
                column: e(C),
                border: ""
              }, {
                default: o(() => [
                  (i(!0), N(K, null, Q(e(S), (G, Fe) => (i(), N(K, { key: Fe }, [
                    G.hidden ? z("", !0) : (i(), v(p, {
                      key: 0,
                      label: G.label
                    }, {
                      default: o(() => [
                        q(ne(ie(H.row, G, Fe)), 1)
                      ]),
                      _: 2
                    }, 1032, ["label"]))
                  ], 64))), 128))
                ]),
                _: 2
              }, 1032, ["column"])
            ]),
            _: 1
          })) : z("", !0),
          e(a) ? (i(), v(l, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: o(({ $index: H }) => [
              q(ne(e(J) + H), 1)
            ]),
            _: 1
          })) : z("", !0),
          (i(!0), N(K, null, Q(e(y), (H, G) => (i(), v(l, B({
            key: G,
            align: H.align || "left",
            label: H.label,
            prop: G
          }, H.tableProps, { "show-overflow-tooltip": "" }), Ae({ _: 2 }, [
            H.columnSlot ? {
              name: "default",
              fn: o((Fe) => [
                (i(), v(Te(H.columnSlot.is), xe($e(ce(H.columnSlot, Fe))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128)),
          A(R.$slots, "table-column"),
          d(l, {
            align: e(P) || "left",
            width: e(F)
          }, {
            header: o(() => [
              e(W) ? (i(), v(pe, {
                key: 0,
                modelValue: e(L)[e(W)],
                "onUpdate:modelValue": O[0] || (O[0] = (H) => e(L)[e(W)] = H),
                placeholder: e(r)[e(W)].label + "\u6A21\u7CCA\u67E5\u627E",
                clearable: "",
                onKeyup: Ue(e(Z), ["enter", "native"])
              }, null, 8, ["modelValue", "placeholder", "onKeyup"])) : (i(), N("span", al, "\u64CD\u4F5C"))
            ]),
            default: o((H) => [
              A(R.$slots, "menu-top", { scope: H }),
              d(fe, {
                plain: "",
                type: H.row[e(V).deleteFlag] ? "danger" : "success",
                onClick: (G) => e(u)(H.row)
              }, {
                default: o(() => [
                  q(ne(H.row[e(V).deleteFlag] ? "\u7981\u7528" : "\u542F\u7528"), 1)
                ]),
                _: 2
              }, 1032, ["type", "onClick"]),
              d(fe, {
                plain: "",
                type: "primary",
                icon: "edit",
                onClick: (G) => e(ee)(H.row)
              }, null, 8, ["onClick"]),
              d(fe, {
                plain: "",
                type: "danger",
                icon: "delete",
                onClick: (G) => e(D)(H.row)
              }, null, 8, ["onClick"]),
              A(R.$slots, "menu-bottom", { scope: H })
            ]),
            _: 3
          }, 8, ["align", "width"])
        ]),
        _: 3
      }, 16, ["data", "row-key", "height"])), [
        [Oe, e(t)]
      ]);
    };
  }
}), nl = /* @__PURE__ */ ge({
  __name: "crud_Pagination",
  setup(n) {
    const { Page_PageSizes: c, Page_PageParams: f, Page_Layout: _, Page_isHideOnSinglePage: a } = he(), { queryRecord: h } = we(), C = (F) => {
      f.value.pageSize = F, h();
    }, P = (F) => {
      f.value.current = F, f.value.current != null && h();
    };
    return (F, E) => {
      const V = m("el-pagination");
      return i(), v(V, {
        "hide-on-single-page": e(a),
        "current-page": e(f).current,
        "page-size": e(f).pageSize,
        "page-sizes": e(c),
        background: "",
        layout: e(_),
        total: e(f).total,
        onSizeChange: C,
        onCurrentChange: P
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), rl = { style: { padding: "20px", "background-color": "#fff" } }, ul = { class: "button_left" }, sl = /* @__PURE__ */ q(" \u65B0\u589E "), dl = /* @__PURE__ */ q(" \u6279\u91CF\u5220\u9664 "), il = { class: "button_right" }, cl = { style: { display: "flex", "justify-content": "flex-end" } }, pl = /* @__PURE__ */ q("\u53D6\u6D88"), fl = /* @__PURE__ */ q("\u91CD\u7F6E"), _l = /* @__PURE__ */ q("\u63D0\u4EA4"), ml = /* @__PURE__ */ ge({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    wrapperStyle: null,
    debug: { type: Boolean, default: () => w.debug },
    mainMaxHeight: { default: () => w.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => w.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => w.isOpenSearchForm },
    Form_LabelWidth: { default: () => w.Form_LabelWidth },
    Dialog_Width: { default: () => w.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => w.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => w.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => w.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => w.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => w.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => w.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => w.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => w.Table_ExpandColumn },
    Page_PageSizes: { default: () => w.Page_PageSizes },
    Page_PageParams: { default: () => w.Page_PageParams },
    Page_Layout: { default: () => w.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => w.Page_isHideOnSinglePage },
    ApiName: { default: () => w.ApiName },
    Permission: { default: () => w.Permission },
    Permissions: { default: () => w.Permissions }
  },
  emits: ["row-contextmenu"],
  setup(n, { emit: c }) {
    const f = n, _ = Ie();
    Je(f);
    const { queryRecord: a, addRecord: h, handleSubmit: C, deleteMulRecord: P } = we(), { CompRef: F, initSearchModel: E, Mode: V, DialogVisible: T, multipleSelection: U, submitLoading: t, DialogVisibleFooterButton: r } = k(), { isOpenSearchForm: y, isAfterMountQuery: S, Table_isOpenMultipleSelection: L, Dialog_Width: re, Dialog_isFullscreen: Y, Dialog_isCloseOnPressEscape: W, Dialog_isCloseOnClickModal: ue, Permission: Z, Permissions: ee } = he();
    if (_.params.data) {
      be("\u8DEF\u7531\u4F20\u53C2\uFF1A", _.params.data);
      let l = _.params.data, p = JSON.parse(l);
      E.value = Pe(E.value, p);
    }
    const u = $(), D = $(), J = $(), g = $(), le = $(0), de = $(0), ie = $(0), ce = $(0);
    De(() => {
      F.value.containerDivRef = u.value, F.value.searchDivRef = D.value, F.value.buttonDivRef = J.value, F.value.paginationDivRef = g.value, le.value = u.value.offsetHeight - 40, de.value = F.value.searchDivRef.offsetHeight, ie.value = F.value.buttonDivRef.offsetHeight, ce.value = F.value.paginationDivRef.offsetHeight, S.value && a();
    });
    const R = ve(() => {
      const l = $(le.value - ie.value - ce.value);
      return y.value ? l.value - de.value : l.value;
    }), O = ve(() => {
      const l = $(document.documentElement.clientHeight);
      return Y.value ? l.value - 54 - 62 - 2 : l.value - 54 - 62 - 2 - l.value * 0.15 - 50;
    }), M = ({ row: l, event: p }, b) => {
      c("row-contextmenu", { row: l, event: p }, b);
    };
    return (l, p) => {
      var pe, fe;
      const b = Re("Auth");
      return i(), N("div", {
        ref_key: "containerDivRef",
        ref: u,
        style: { height: "100%" }
      }, [
        X("div", rl, [
          X("div", {
            ref_key: "searchDivRef",
            ref: D
          }, [
            ye(d(Ye, null, {
              "search-form": o(() => [
                A(l.$slots, "search-form", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-top": o(() => [
                A(l.$slots, "search-form-top", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              "search-form-bottom": o(() => [
                A(l.$slots, "search-form-bottom", {
                  CrudState: e(k)()
                }, void 0, !0)
              ]),
              _: 3
            }, 512), [
              [Le, e(y)]
            ])
          ], 512),
          X("div", {
            ref_key: "buttonDivRef",
            ref: J,
            class: "buttonDiv"
          }, [
            X("div", ul, [
              ye((i(), v(e(oe), {
                type: "primary",
                icon: "plus",
                onClick: e(h)
              }, {
                default: o(() => [
                  sl
                ]),
                _: 1
              }, 8, ["onClick"])), [
                [b, { Permissions: e(ee), access: [(pe = e(Z)) == null ? void 0 : pe.add] }]
              ]),
              e(L) ? ye((i(), v(e(oe), {
                key: 0,
                disabled: e(U).length <= 0,
                type: "danger",
                icon: "delete",
                onClick: e(P)
              }, {
                default: o(() => [
                  dl
                ]),
                _: 1
              }, 8, ["disabled", "onClick"])), [
                [b, { Permissions: e(ee), access: [(fe = e(Z)) == null ? void 0 : fe.remove] }]
              ]) : z("", !0),
              A(l.$slots, "button-left", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            X("div", il, [
              A(l.$slots, "button-right", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            d(e(Ke), { style: { "flex-shrink": "0", width: "150px" } }, {
              default: o(() => [
                d(e(oe), {
                  color: "#67c23a",
                  icon: "search",
                  onClick: e(a)
                }, null, 8, ["onClick"]),
                d(e(oe), {
                  color: "#e6a23c",
                  icon: "refresh",
                  onClick: p[0] || (p[0] = (I) => e(F).SearchFormRef.resetFields())
                }),
                d(e(oe), {
                  color: "#409eff",
                  icon: "expand",
                  onClick: p[1] || (p[1] = (I) => y.value = !e(y))
                })
              ]),
              _: 1
            })
          ], 512),
          d(tl, {
            height: e(R),
            onRowContextmenu: M
          }, {
            "table-column": o(() => [
              A(l.$slots, "table-column", {
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-top": o((I) => [
              A(l.$slots, "menu-top", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            "menu-bottom": o((I) => [
              A(l.$slots, "menu-bottom", {
                scope: I,
                CrudState: e(k)()
              }, void 0, !0)
            ]),
            _: 3
          }, 8, ["height"]),
          X("div", {
            ref_key: "paginationDivRef",
            ref: g,
            style: { "padding-top": "20px" }
          }, [
            d(nl)
          ], 512),
          d(e(qe), {
            class: "DialogVisible",
            modelValue: e(T),
            "onUpdate:modelValue": p[5] || (p[5] = (I) => Ne(T) ? T.value = I : null),
            title: e(V) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
            width: e(re),
            "close-on-press-escape": e(W),
            fullscreen: e(Y),
            "close-on-click-modal": e(ue)
          }, Ae({
            default: o(() => [
              d(ol, { height: e(O) }, {
                "edit-form": o(() => [
                  A(l.$slots, "edit-form", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-top": o(() => [
                  A(l.$slots, "edit-form-top", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                "edit-form-bottom": o(() => [
                  A(l.$slots, "edit-form-bottom", {
                    CrudState: e(k)()
                  }, void 0, !0)
                ]),
                _: 3
              }, 8, ["height"])
            ]),
            _: 2
          }, [
            e(r) ? {
              name: "footer",
              fn: o(() => [
                X("div", cl, [
                  A(l.$slots, "edit-form-footer", {}, void 0, !0),
                  d(e(oe), {
                    onClick: p[2] || (p[2] = (I) => T.value = !1)
                  }, {
                    default: o(() => [
                      pl
                    ]),
                    _: 1
                  }),
                  d(e(oe), {
                    type: "warning",
                    plain: "",
                    onClick: p[3] || (p[3] = (I) => e(F).EditFormRef.resetFields())
                  }, {
                    default: o(() => [
                      fl
                    ]),
                    _: 1
                  }),
                  d(e(oe), {
                    type: "primary",
                    loading: e(t),
                    onClick: p[4] || (p[4] = (I) => e(C)(e(F).EditFormRef))
                  }, {
                    default: o(() => [
                      _l
                    ]),
                    _: 1
                  }, 8, ["loading"])
                ])
              ])
            } : void 0
          ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
        ])
      ], 512);
    };
  }
});
const Se = /* @__PURE__ */ Be(ml, [["__scopeId", "data-v-1c478c0a"]]), bl = {
  mounted(n, c, f) {
    const _ = c.value.Permissions, a = c.value.access;
    let h = !1;
    for (let C = 0; C < a.length; C++)
      _.includes(a[C]) && (h = !0);
    h || n.parentNode && n.parentNode.removeChild(n);
  }
};
Se.install = (n) => {
  n.component("CrudEl", Se), n.directive("Auth", bl);
};
const Fl = (n, c) => {
  c ? (c.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Qe(c), n.use(Se)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  Pe as DataMerger,
  j as DeepClone,
  Qe as InitSys,
  Fl as createCrudEl,
  ae as hooksName,
  je as isObjEqual,
  We as useHooks
};
